Rooster 发表于 2022-7-6 12:05:01

帮助编辑LISP

我遇到了一个LISP,它将线型分解为它们的组成线,我确实偶尔可以使用它。唯一的问题是,当LISP分解线型时,它会将所有内容放入第0层。有没有人能帮我编辑这个LISP,使线条理想地停留在它们已经在的层中,或者至少让我为它们选择一个不同的层?谢谢
 
;;;        EXPLODES LINETYPES INTO INDIVIDUAL COMPONENTS
;;;
;;;    By Dominic Panholzer
;;;
;;;    Modified original TXTEXP.LSP from Express Tools
;;;    Copyright © 1999 by Autodesk, Inc.
;;   LINEXP.LSP modifications by XANADU
;;;
;;;    Your use of this software is governed by the terms and conditions of the
;;;    License Agreement you accepted prior to installation of this software.
;;;    Please note that pursuant to the License Agreement for this software,
;;;    "opying of this computer program or its documentation except as
;;;    permitted by this License is copyright infringement under the laws of
;;;    your country.If you copy this computer program without permission of
;;;    Autodesk, you are violating the law."
;;;
;;;    AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
;;;    AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
;;;    MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.AUTODESK, INC.
;;;    DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
;;;    UNINTERRUPTED OR ERROR FREE.
;;;
;;;    Use, duplication, or disclosure by the U.S. Government is subject to
;;;    restrictions set forth in FAR 52.227-19 (Commercial Computer
;;;    Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
;;;    (Rights in Technical Data and Computer Software), as applicable.
;;;
;;;----------------------------------------------------------------
;;;
;;;External Functions:
;;;
;;;   ACET-ERROR-INIT         --> ACETUTIL.FAS   Intializes bonus error routine
;;;   ACET-ERROR-RESTORE      --> ACETUTIL.FAS   Restores old error routine
;;;   ACET-GEOM-ZOOM-FOR-SELECT --> ACETUTIL.FAS   Zoom boundry to include points given
;;;   ACET-LAYER-LOCKED         --> ACETUTIL.FAS   Checks to see if layer is locked
;;;   ACET-GEOM-PIXEL-UNIT      --> ACETUTIL.FAS   Size of pixel in drawing units
;;;   ACET-GEOM-TEXTBOX         --> ACETUTIL.FAS   Returns the textbox for any text
;;;   ACET-GEOM-MIDPOINT      --> ACETUTIL.FAS   Returns midpoint between two points
;;;   ACET-GEOM-VIEW-POINTS   --> ACETUTIL.FAS   Returns corner points of screen or viewport
;;;   ACET-STR-FORMAT         --> ACETUTIL.ARX   String builder
;;;   ACET-WMFIN                --> ACETUTIL.FAS   Brings in WMF file
;;;

(defun c:linexp (/ grplst getgname blknm FLTR GLST GDICT SS VIEW UPLFT TMPFIL TBX
                  TMPFIL CNT PT1 PT2 ENT TXT TXTYP PTLST ZM LOCKED GNAM vpna vplocked)
(acet-error-init
       (list
      (list   "cmdecho" 0
                "highlight" 1
                "osmode" 0
                "Mirrtext" 1
                "limcheck" 0
      )
      T
       )
)

; --------------------- GROUP LIST FUNCTION ----------------------
;   This function will return a list of all the group names in the
;   drawing and their entity names in the form:
;   ((<ename1> . <name1>) ... (<enamex> . <namex>))
; ----------------------------------------------------------------

(defun acet-txtexp-grplst (/ GRP ITM NAM ENT GLST)

   (setq GRP(dictsearch (namedobjdict) "ACAD_GROUP"))
   (while (setq ITM (car GRP))       ; While edata item is available
   (if (= (car ITM) 3)             ; if the item is a group name
       (setq NAM (cdr ITM)         ; get the name
             GRP (cdr GRP)         ; shorten the edata
             ITM (car GRP)         ; get the next item
             ENT (cdr ITM)         ; which is the ename
             GRP (cdr GRP)         ; shorten the edata
             GLST                  ; store the ename and name
               (if GLST
                   (append GLST (list (cons ENT NAM)))
                   (list (cons ENT NAM))
               )
       )
       (setq GRP (cdr GRP))          ; else shorten the edata
   )
   )
   GLST                              ; return the list
)

; ------------------- GET GROUP NAME FUNCTION --------------------
;   This function returns a list of all the group names in GLST
;   where ENT is a member. The list has the same form as GLST
; ----------------------------------------------------------------

(defun acet-txtexp-getgname (ENT GLST / GRP GDATA NAM NLST)
   (if (and GLST (listp GLST))
   (progn
       (foreach GRP GLST
         (setq GDATA (entget (car GRP)))
         (foreach ITM GDATA                   ; step through the edata
         (if (and
               (= (car ITM) 340)            ; if the item is a entity name
               (eq (setq NAM (cdr ITM)) ENT) ; and the ename being looked for
               )
             (setq NLST                     ; store the ename and name
                     (if NLST
                     (append NLST (list (cons (car GRP) (cdr GRP))))
                     (list (cons (car GRP) (cdr GRP)))
                     )
             )
         )
         )
       )
   )
   )
   NLST
)

; ----------------------------------------------------------------
;                        MAIN PROGRAM
; ----------------------------------------------------------------

(if (and                                                ; Are we in plan view?
       (equal (car (getvar "viewdir")) 0 0.00001)
       (equal (cadr (getvar "viewdir")) 0 0.00001)
       (> (caddr (getvar "viewdir")) 0)
   )

   (progn

   (prompt "\nSelect lines to be EXPLODED: ")

   (Setq FLTR    '((-4 . "<AND")
                     (-4 . "<OR")                      ; filter for mtext and text
                         (0 . "MTEXT")
                         (0 . "TEXT")
                     (-4 . "OR>")
                     (-4 . "<NOT")
                         (102 . "{ACAD_REACTORS")      ; and not leader text
                     (-4 . "NOT>")
                     (-4 . "AND>")
                  )
         GLST   (acet-txtexp-grplst)                           ; Get all the groups in drawing
         GDICT    (if GLST
                      (dictsearch (namedobjdict) "ACAD_GROUP")
                  )
         SS       (ssget);FLTR)
         CNT      0
   )
   ;; filter out the locked layers
   (if SS
       (setq SS (car (bns_ss_mod SS 1 T)))
   ) ;if

   ;; if we have anything left
   (if SS
       (progn
         (setq CNT 0)                                 ; Reset counter
         (while (setq ENT (ssname SS CNT))            ; step through each object in set

         (and
             GLST                                     ; if groups are present in the drawing
             (setq GNAM (acet-txtexp-getgname ENT GLST))          ; and the text item is in one or more
             (foreach GRP GNAM                        ; step through those groups
               (command "_.-group" "_r"               ; and remove the text item
               (cdr GRP) ENT ""
               )
             )
         )

         (setq TBX (acet-geom-textbox (entget ENT) 0))   ; get textbox points

         (setq TBX (mapcar '(lambda (x)
                              (trans x 1 0)         ; convert the points to WCS
                              )
                     TBX
                     )
         )

         (setq PTLST (append PTLST TBX))            ; Build list of bounding box
                                                      ; points for text items selected

         (setq CNT (1+ CNT))                        ; get the next text item
         ); while

         (setq PTLST (mapcar '(lambda (x)
                              (trans x 0 1)         ; convert all the points
                              )                     ; to the current ucs
                     PTLST
                   )
         )

         (if (setq ZM (acet-geom-zoom-for-select PTLST))          ; If current view does not contain
         (progn                                     ; all bounding box points
             (setq ZM
               (list
               (list (- (caar ZM) (acet-geom-pixel-unit))   ; increase zoom area by
                     (- (cadar ZM) (acet-geom-pixel-unit))    ; one pixel width to
                     (caddar ZM)                  ; sure nothing will be lost
               )
               (list (+ (caadr ZM) (acet-geom-pixel-unit))
                     (+ (cadadr ZM) (acet-geom-pixel-unit))
                     (caddr (cadr zm))
               )
               )
             )
             (if (setq vpna (acet-currentviewport-ename))
               (setq vplocked (acet-viewport-lock-set vpna nil))
             );if
             (command "_.zoom" "_w" (car ZM) (cadr ZM)); zoom to include text objects
         )
         )

         (setq VIEW   (acet-geom-view-points)
               TMPFIL   (strcat (getvar "tempprefix") "txtexp.wmf")
               PT1      (acet-geom-midpoint (car view) (cadr view))
               PT2      (list (car PT1) (cadadr VIEW))
         )

         (if (acet-layer-locked (getvar "clayer"))       ; if current layer is locked
         (progn
             (command "_.layer" "_unl" (getvar "clayer") ""); unlock it
             (setq LOCKED T)
         )
         )

         (command "_.mirror" SS "" PT1 PT2 "_y"
                  "_.WMFOUT" TMPFIL SS "")

         (if (findfile tmpfil)                           ; Does WMF file exist?
         (progn
             (command "_.ERASE" SS "")                   ; erase the orignal text
             (setq ss (acet-wmfin TMPFIL))               ; insert the WMF file
             (command "_.mirror" ss "" PT1 PT2 "_y")
         ) ;progn
         ) ;if


         (if LOCKED
         (command "_.layer" "_lock" (getvar "clayer") "") ; relock if needed
         ) ;if

         (if ZM (command "_.zoom" "_p"))            ; Restore original view if needed
         (if vplocked
             (acet-viewport-lock-set vpna T) ;re-lock the viewport if needed.
         );if
         (prompt (acet-str-format "\n%1 object(s) have been exploded to lines."CNT))
         (prompt "\nThe line objects have been placed on layer 0.")
       )
   )
   )
   (prompt "\nView needs to be in plan (0 0 1).")
);if equal
(acet-error-restore)                                  ; Retsore values
(princ)
)


(princ)

alanjt 发表于 2022-7-6 12:18:05

;;;    Your use of this software is governed by the terms and conditions of the
;;;    License Agreement you accepted prior to installation of this software.
;;;    Please note that pursuant to the License Agreement for this software,
;;;    "opying of this computer program or its documentation except as
;;;    permitted by this License is copyright infringement under the laws of
;;;    your country.If you copy this computer program without permission of
;;;    Autodesk, you are violating the law."
 
 
嗯。。。。。。。。。。。。

Freerefill 发表于 2022-7-6 12:25:13

最简单的解决方案是编写另一个lisp,将当前工作层“clayer”更改为您希望它们位于的任何层,然后分解该行,然后更改回您开始使用的内容。不过,这是一个非常好的解决方案。

Rooster 发表于 2022-7-6 12:31:36

 
但是,在运行LISP时,我当前的工作层不是0层。。。。

Freerefill 发表于 2022-7-6 12:46:09

我把它翻了一遍,不管是谁最初修改了LISP,几乎什么都没做。
 
我并没有亲自修改它,相反,我通过它找到了工作元素,并重新编写了所需的内容。
 
是的,就是这样。与acet wmfin函数有关。你可能需要对其进行编辑,以确定它必须位于哪一层。
 
*编辑*已在此处提出问题:
http://discussion.autodesk.com/forums/thread.jspa?threadID=646386
TL;DR,由于它在选择集上操作,并且每个项目可能位于不同的层上,因此它无法将它们放置在其原始层上,除非每个项目在acet wmfin中单独迭代。
 
*编辑编辑*我将保留第一个,因为它快速而干净,但显然acet wmfin将处理实体和选择集。我设置了一个快速循环来替换图层,并将颜色设置为“bylayer”您可能还可以想出如何将颜色重置为原始颜色。
3

Rooster 发表于 2022-7-6 12:53:44

谢谢,这很有帮助

Rooster 发表于 2022-7-6 13:03:02

最近一直在使用它,它在我的工作电脑上运行良好,但在家使用它(AutoCAD的相同版本等)时,我收到以下错误消息,然后该功能结束:
 
C: \txtexp。wmf:无法打开文件
 
 
有人能帮忙吗?

Freerefill 发表于 2022-7-6 13:10:20

试着键入命令“wmfin”,看看会发生什么。它会提示您输入一个。wmf文件。试试看你有没有txtexp。C:\驱动器中的wmf文件。
 
顺便说一句,我很高兴你能从中得到一些帮助。^
页: [1]
查看完整版本: 帮助编辑LISP